#ifndef _ELMOPLOG_H
#define _ELMOPLOG_H

#ifdef __KERNEL__
#include <linux/plog.h>
#else
#include <tivocall/tivocall.h>
#endif

// define DO_ELMO_PLOG to get plogging of elmo RPCs
#undef DO_ELMO_PLOG

#ifdef DO_ELMO_PLOG
#define PLOG(t,l,a) process_log(t,l,a)
#else
#define PLOG(t,l,a)
#endif

#define PLOG_ELMO_RPC_SEND 400
// "RPC send called for 0x%x"

#define PLOG_ELMO_RPC_TEID_READ 401
// "RPC received by TEID"

#define PLOG_ELMO_RPC_RESPONSE_CALLBACK 402
// "RPC response delivered to client 0x%x"

#define PLOG_ELMO_RPC_NOTIFICATION_CALLBACK 403
// "RPC notification delivered to client 0x%x"

#define PLOG_ELMO_RPC_BEFORE_CALL 404
// "RPC before the call"

#define PLOG_ELMO_RPC_AFTER_CALL 405
// "RPC after the call"

#define PLOG_ELMO_RPC_BEFORE_LL_WRITE 406
// "RPC before LL write"

#define PLOG_ELMO_RPC_AFTER_LL_WRITE 407
// "RPC after LL write"

#define PLOG_ELMO_RPC_TEID_QUEUED 408
// "RPC message queued for client by TEID"

#define PLOG_ELMO_RPC_TEID_NOTIFICATION 409
// "RPC notification queued for client by TEID"

#define PLOG_ELMO_RPC_DATA_SENT_TO_FIFO 410
// "RPC sent to FIFO, left %d bytes"

#define PLOG_ELMO_RPC_NEW_DATA_FROM_ESS 411
// "RPC new data comes, %d bytes"

#define PLOG_ELMO_RPC_NEW_DATA_WAITING_FOR 412
// "RPC has more room, %d bytes"

#define PLOG_ELMO_RPC_LL_WRITE_DONE 413
// "RPC low latency write done"

#define PLOG_ELMO_RPC_WORKER_STATE 414
// "RPC worker state %d"

#define PLOG_ELMO_RPC_READV_STARTED 415
// "RPC readv started"

#define PLOG_ELMO_RPC_READV_HAS 416
// "RPC readv has %d bytes"

#define PLOG_ELMO_RPC_READV_HAS2 417
// "RPC readv has %d bytes before return"

#define PLOG_ELMO_RPC_ELMO_INTERRUPT 418
// "RPC elmo interrupt ISR.FSR 0x%08x"

#endif /* _ELMOPLOG_H */
